// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_incoming_connections_count.sql

package queries

import (
	"context"
)

const listIncomingConnectionsCount = `-- name: ListIncomingConnectionsCount :one

SELECT
    count(*) as total_count
FROM (
         SELECT outway_peer_id, service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, null as delegator_peer_id
         FROM contracts.grants_service_connection
         WHERE service_peer_id = $1::text
         UNION DISTINCT
         SELECT outway_peer_id,service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, delegator_peer_id as delegator_peer_id
         FROM contracts.grants_delegated_service_connection
         WHERE service_peer_id = $1::text
     ) AS p
         JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
WHERE
    CASE
        when cardinality($2::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($2::text[]))
        end
`

type ListIncomingConnectionsCountParams struct {
	SelfPeerID     string
	ContractStates []string
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) ListIncomingConnectionsCount(ctx context.Context, arg *ListIncomingConnectionsCountParams) (int64, error) {
	row := q.db.QueryRow(ctx, listIncomingConnectionsCount, arg.SelfPeerID, arg.ContractStates)
	var total_count int64
	err := row.Scan(&total_count)
	return total_count, err
}
